SystemOrganization addCategory: #'TyH-TP-Final'!
SystemOrganization addCategory: #'TyH-TP-Final-Test'!
SystemOrganization addCategory: #'TyH-TP-Final-Modelo'!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!Emisor class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 21:58'!
crear: unDNI nombre: unNombre apellido: unApellido cuit: unCUIT direccion: unaDireccion

| instancia |

instancia := Emisor new.

instancia setDNI: unDNI.
instancia setNombre: unNombre.
instancia setApellido: unApellido.
instancia setCUIT: unCUIT.
instancia setDireccion: unaDireccion.

^ instancia.


	! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:50'!
getApellido
	^apellido 

! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getCUIT
	^CUIT! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDNI
	^DNI! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDireccion
	^direccion ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:52'!
getNombre
	^nombre ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setApellido: unApellido

	apellido := unApellido.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setCUIT: unCUIT

	CUIT := unCUIT.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDNI: unDNI

	DNI :=DNI.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDireccion: unaDireccion

	direccion := unaDireccion.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setNombre: unNombre

	nombre := unNombre.! !

Object subclass: #Orden
	instanceVariableNames: 'cantidadUnidades fechaIngreso precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 19:02'!
calcularPrecioUnitario
	^(precio / cantidadUnidades)! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 16:43'!
getCantidadUnidades
    ^cantidadUnidades ! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/4/2012 18:42'!
getFechaIngreso
    ^Date readFromString: fechaIngreso! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:06'!
getPrecio
    ^precio! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setCantidadUnidades: unaCantidadUnidades
	cantidadUnidades  := unaCantidadUnidades ! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setFechaIngreso: unaFechaIngreso
	fechaIngreso := unaFechaIngreso ! !

!Orden methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:09'!
setPrecio: unPrecio
	precio := unPrecio ! !

Orden subclass: #OrdenCompra
	instanceVariableNames: 'direccionRecepcion formaEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenCompra class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:47'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
recibirEn:unaDireccionRecepcion
enviarComo: unaFormaEnvio

| instancia |

instancia := OrdenCompra new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setDireccionRecepcion: unaDireccionRecepcion.
instancia setFormaEnvio: unaFormaEnvio.

^instancia 
! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getDireccionRecepcion
 ^direccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getFormaEnvio
 ^formaEnvio ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:30'!
setDireccionRecepcion: unaDireccionRecepcion
  direccionRecepcion  := unaDireccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
setFormaEnvio: unaFormaEnvio
 ^formaEnvio := unaFormaEnvio ! !

Orden subclass: #OrdenVenta
	instanceVariableNames: 'fechaDisponibilidad medioPago'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenVenta class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:50'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
disponibleEnFecha:unaFechaDisponibilidad
pagoEn: unMedioPago

| instancia |

instancia := OrdenVenta new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setFechaDisponibilidad: unaFechaDisponibilidad.
instancia setMedioPago: unMedioPago.

^instancia 
! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getFechaDisponibilidad
 ^fechaDisponibilidad  ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getMedioPago
 ^medioPago ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
setFechaDisponibilidad: unaFechaDisponibilidad
  fechaDisponibilidad   := unaFechaDisponibilidad ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:32'!
setMedioPago: unMedioPago
  medioPago := unMedioPago ! !

Object subclass: #OrdenTest
	instanceVariableNames: 'precio cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

!OrdenTest class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:52'!
crear: unaCantidad precio:unPrecio

| instancia |

instancia := OrdenTest new.

instancia setCantidad: unaCantidad.
instancia setPrecio: unPrecio.

^instancia.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
getCantidadDeHijos 

^cantidad.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
getPrecioMercado 

^precio.
! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:50'!
setCantidad: unaCantidad

cantidad := unaCantidad.! !

!OrdenTest methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:49'!
setPrecio: unPrecio

precio := unPrecio.! !

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrderBook class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:21'!
crear

| instancia | 

instancia := OrderBook new.

instancia inicializar.

^instancia.
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:22'!
agregarOrdenCompra: unaOrden

ordenesCompra add: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:23'!
agregarOrdenVenta: unaOrden

ordenesVenta add: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:15'!
getOrdenesCompra
^ordenesCompra! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:52'!
getOrdenesVenta

^ordenesVenta.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/4/2012 20:41'!
inicializar

ordenesCompra := OrderedCollection new.
ordenesVenta := OrderedCollection new.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/4/2012 20:43'!
obtenerOrdenesCompraCandidatas: unPrecioMercado

| ordenesCompraCantidatasFiltradas ordenesCompraCandidatasOrdenadas | 

"Filtrar las ordenes de compra candidatas, es decir las ordenes de compra con precio > al precio de mercado"
ordenesCompraCantidatasFiltradas := ordenesCompra select: [:unaOrdenCompra | (unaOrdenCompra calcularPrecioUnitario) >= unPrecioMercado].

ordenesCompraCandidatasOrdenadas := ordenesCompraCantidatasFiltradas asSortedCollection: 
     [:unaOrdenCompra :otraOrdenCompra | 
	((unaOrdenCompra calcularPrecioUnitario) > (otraOrdenCompra calcularPrecioUnitario)) &
	((unaOrdenCompra getFechaIngreso) < (otraOrdenCompra getFechaIngreso))
	].

^ ordenesCompraCandidatasOrdenadas ! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/4/2012 20:50'!
obtenerOrdenesVentaCandidatas: unPrecioMercado

| ordenesVentaCantidatasFiltradas ordenesVentaCandidatasOrdenadas | 

"Filtrar las ordenes de centa candidatas, es decir las ordenes de venta con precio < al precio de mercado"
ordenesVentaCantidatasFiltradas := ordenesVenta  select: [:unaOrdenVenta | (unaOrdenVenta calcularPrecioUnitario) <= unPrecioMercado].

ordenesVentaCandidatasOrdenadas := ordenesVentaCantidatasFiltradas asSortedCollection: 
	[:unaOrdenVenta :otraOrdenVenta | 
	((unaOrdenVenta calcularPrecioUnitario) < (otraOrdenVenta calcularPrecioUnitario)) &
	((unaOrdenVenta getFechaIngreso) < (otraOrdenVenta getFechaIngreso))
	].

^ ordenesVentaCandidatasOrdenadas 
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenCompra: unaOrden

ordenesCompra remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenVenta: unaOrden

ordenesVenta remove: unaOrden.! !

Object subclass: #PEM
	instanceVariableNames: 'emisores tickets orderBook ocCandidatas ovCandidatas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!PEM class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 12:50'!
crear
	"Crea una nueva instancia del PEM con las colecciones incializadas"

	| instancia |

instancia := PEM new.
instancia inicializar.
^instancia.
! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:06'!
agregarEmisor: unEmisor

"Agrega un nuevo emisor al PEM"

	emisores add: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:06'!
agregarOrdenCompra: unaOrden

"Agrega una nueva orden de compra al PEM"

orderBook agregarOrdenCompra: unaOrden.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:06'!
agregarOrdenVenta: unaOrden

"Agrega una nueva orden de venta al PEM"

orderBook agregarOrdenVenta: unaOrden.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:07'!
agregarTradingTicket: unTicket

"Agrega un nuevo Ticket al PEM"

tickets add: unTicket.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:30'!
calcularPrecioMercado 

| tabla |

"Calcula del precio del mercado en funcin de las ordenes registradas hasta el momento. 
Para calcular el precio del mercado la clase PEM hace uso de la clase TablaPrecioMercado a quien sabe como calcular este precio".

tabla := TablaPrecioMercado crear.

"1 - Agrega todas las ordenes de compra a la tabla" 

(orderBook getOrdenesCompra) do: [:oc |
	
		tabla agregarDemandaPrecio: oc calcularPrecioUnitario cantidad: oc getCantidadUnidades ].

"2 - Agrega todas las ordenes de venta a la tabla"

(orderBook getOrdenesVenta) do: [:ov |
	
		tabla agregarOfertaPrecio: ov calcularPrecioUnitario cantidad: ov getCantidadUnidades].

" 3 - Obtiene el precio del mercado"
"^tabla calcularPrecioMercado."

^30.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/4/2012 22:22'!
ejecutarTrading

"Ejecuta el proceso de trading"
	
	| precioMercadoCalculado ovTransaccionada ovMatcheadas tradingTicket |

	precioMercadoCalculado := self calcularPrecioMercado.
	ovCandidatas := orderBook obtenerOrdenesVentaCandidatas: precioMercadoCalculado.
	ocCandidatas := orderBook obtenerOrdenesCompraCandidatas: precioMercadoCalculado.
	
	"Recorre las OC candidatas y las compara una a una contra las OV con igual cantidad"	
	ocCandidatas do: [:ocTransaccionando | 
					
			ovMatcheadas := ovCandidatas select: [:ov | ov getCantidadUnidades = ocTransaccionando getCantidadUnidades].
			
			(ovMatcheadas size > 0)
 			ifTrue: [ 
				
				"Toma la primera OV con igual cantidad"	
				ovTransaccionada := ovMatcheadas first. 
			
				"Crea el Trading Ticket y remueve las ordenes del orderbook"
				tradingTicket := TradingTicket crear: ocTransaccionando ordenVenta: ovTransaccionada precioMercado: precioMercadoCalculado.			
				orderBook quitarOrdenCompra: ocTransaccionando.
				orderBook quitarOrdenVenta: ovTransaccionada.
		  		   ].
			 ].
			! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 20:44'!
getEmisores

^emisores.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:09'!
getOrderbook
^orderBook ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 12:29'!
inicializar

"Inicializa las colecciones del PEM"

emisores := OrderedCollection new.
tickets := OrderedCollection new. 
orderBook := OrderBook new inicializar.
ocCandidatas := SortedCollection new.
ovCandidatas := SortedCollection new.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:07'!
quitarEmisor: unEmisor

emisores remove: unEmisor.! !

Object subclass: #RegistroTablaPrecioMercado
	instanceVariableNames: 'precio demanda oferta demandaTeorica ofertaTeorica'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!RegistroTablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:51'!
crear: unPrecio

| instancia |

instancia := RegistroTablaPrecioMercado new.
instancia inicializar.
instancia setPrecio: unPrecio.

^instancia.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
calcularUnidadesTeoricas

| resultado |

resultado := 0.

(demandaTeorica <= ofertaTeorica ) ifFalse: [resultado:= ofertaTeorica]  ifTrue: [resultado := demandaTeorica].

^resultado.
! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getDemanda

^demanda.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:02'!
getDemandaTeorica

^demandaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getOferta

^oferta.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:03'!
getOfertaTeorica

^ofertaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getPrecio

^precio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
inicializar

precio := 0.
demanda := 0.
oferta := 0.
demandaTeorica :=0.
ofertaTeorica :=0.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
setPrecio: unPrecio

precio := unPrecio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:06'!
sumarDemanda: unaCantidad

demanda := demanda + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarDemandaTeorica: unaCantidad


demandaTeorica := demandaTeorica + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:57'!
sumarOferta: unaCantidad

oferta := oferta + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarOfertaTeorica: unaCantidad

ofertaTeorica := ofertaTeorica + unaCantidad.! !

Object subclass: #TablaPrecioMercado
	instanceVariableNames: 'filas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
crear

| instancia |

instancia := TablaPrecioMercado new.
instancia inicializar.

^instancia.

! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
agregarDemandaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarDemanda:  unaCantidad.

(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarDemanda: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:56'!
agregarOfertaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarOferta: unaCantidad.


(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarOferta: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:29'!
calcularDemandaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) <= (otraFila getPrecio)) ifTrue: [fila sumarDemandaTeorica: (otraFila getDemanda)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:31'!
calcularOfertaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) >= (otraFila getPrecio)) ifTrue: [fila sumarOfertaTeorica: (otraFila getOferta)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:30'!
calcularPrecioMercado

| precioMercado unidadesTeoricas |

precioMercado := 0.
unidadesTeoricas :=0.


self calcularOfertaTeoricaPorPrecio.
self calcularDemandaTeoricaPorPrecio.

filas do: [:fila |
	
	(unidadesTeoricas < fila calcularUnidadesTeoricas)	 ifTrue: [
													unidadesTeoricas:= fila calcularUnidadesTeoricas.
													precioMercado := fila getPrecio.]
	
	].


^precioMercado.! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 17:57'!
inicializar

filas := Dictionary new.

! !

Object subclass: #TradingTicket
	instanceVariableNames: 'ordenCompra ordenVenta fechaTransaccion precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TradingTicket class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:15'!
crear: unaOrdenCompra ordenVenta: unaOrdenVenta precioMercado: unPrecio

| instancia | 


instancia := TradingTicket new.

instancia setPrecioMercado: unPrecio.
instancia setOrdenCompra: unaOrdenCompra.
instancia setOrdenVenta: unaOrdenVenta.
instancia setFechaTransaccion: Date today.

^instancia.
! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:11'!
getFechaTransaccion

	^fechaTransaccion.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenCompra

	^ordenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenVenta

	^ordenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getPrecioMercado

	^precioMercado.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setFechaTransaccion: unaFecha

fechaTransaccion := unaFecha.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenCompra: unaOrdenCompra

ordenCompra := unaOrdenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenVenta: unaOrdenVenta

ordenVenta = unaOrdenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:13'!
setPrecioMercado: unPrecio

precioMercado := unPrecio.! !
